#include <stdint.h>
#include <stdio.h>

#include "parsing.h"
#include "response.h"
#include "scan.h"

void print_usage(void)
{
	// TODO
}

static void print_port_state(uint16_t port, e_scantype type, const struct response * response)
{
	if (type != SCAN_ALL && response->states[type] == CLOSED)
		return;
	printf("%-5d %-12s ", port,
	       response->service ? response->service : "Unassigned");
	if (type == SCAN_ALL)
		for (e_scantype i = SCAN_NULL; i < SCAN_ALL; i++)
			printf("%s(%s) ", types_str[i],
			       states_str[response->states[i]]);
	else
		printf("%s(%s) ", types_str[type],
		       states_str[response->states[type]]);
	printf("\n");
}

void print_host_results(const struct scan *general, double scan_time)
{
	printf("Scan took %lf secs\n", scan_time);
	printf("IP address: %s\n", general->dest_addr);
	printf("Open ports:\n");
	for (uint16_t port = general->port_start; port < general->port_end; port++) {
		print_port_state(port, general->type, &general->responses[port - general->port_start]);
	}
}
